"""
**********************************************************************
File Name:      TEST_S_SMS.py
Dev:            Daniele De Santis
Email:          desantis@areasx.com
Web:            http://www.areasx.com

Versione:       0.1
Data:           28/03/08
Note Hardware:  Processore
Note Software:  
**********************************************************************
"""
import GPIO
import MOD
import MDM

r=GPIO.setIOdir(10,0,1) #setto il port 10 come output e ha come valore di default 0 (LED AUX)
r=GPIO.setIOdir(1,0,0)  #Setto il port 1 come input

_SERVICE_CENTER = "+393359609600"  #Usare il +39!!
_GSMNUMBER_DEST = "+393470000000"

#inizializza il modem
def InitModem():
  res = MDM.send('AT\r', 0) #Invio comando AT
  res = MDM.receive(3) #Attendo 3 sec
  if(res.find('OK') == -1): #NONicevuto "OK"
    return 0
  #Attivo la modalit TEXT
  res = MDM.send("AT+CMGF=1\r", 0)
  res = MDM.receive(3)
  if(res.find('OK') == -1):
    return 0
  #setta il centro servizzi
  TXbuff="AT+CSCA=\"%s\",145\r" % (_SERVICE_CENTER)
  res = MDM.send(TXbuff, 0)
  res = MDM.receive(3)
  if(res.find('OK') == -1):
    return 0
  else:
    return 1
    
#Invia un SMS 
def SendSMS(gsmnumber, message):
  TXbuff="AT+CMGS=\"%s\"\r" % (gsmnumber)
  res = MDM.send(TXbuff, 0)
  #attendo il >
  timer=MOD.secCounter()
  while(1):
    res = MDM.receive(2)
    #print res
    if (MOD.secCounter()>timer+5): #Timeout 5 sec 
      return 0
      break
    if(res.find('>') != -1):
      break
  #Invio il testo dell'SMS
  TXbuff = message + chr(26) + "\r" #appendo CTRL + Z
  res = MDM.send(TXbuff, 0) #invio la stringa 
  timer=MOD.secCounter()
  while(1):
    res = MDM.receive(3) 
    if (MOD.secCounter()>timer+10): #Timeout 10 sec
      return 0
      break
    if(res.find('ERROR') != -1):
      return 0
      break
    if(res.find('OK') != -1):
      return 1
      break
      
#########################
#MAIN
#########################
InitModem()
MOD.sleep(100)

while(1):
  s=GPIO.setIOvalue(10,1) #Accendo il LED AUX
  if(GPIO.getIOvalue(1)==0):
    s=GPIO.setIOvalue(10,0) 
    if(SendSMS(_GSMNUMBER_DEST, "Test dall'EZ863")==1):
      print "Invio SMS riuscito"
    else:
      print "ERRORE Invio SMS fallito"